#include<stdlib.h>
#include<time.h>
#include<stdio.h>
#include<alloc.h>
#include<mem.h>
#include<dos.h>
#include<conio.h>
#include<process.h>

// TRATAMENTO DE ERRO
//--------------------------------------------------------------------------
// Erro - Aborta o programa e imprime uma mensagem caso aconteca algum erro
void Erro(char *a)
{
printf("Erro: %s",a);
exit(0);
}

// ROTINAS GRAFICAS
//---------------------------------------------------------------------------
// SetMode - Define modo de video
void SetMode(int mode)
{
union REGS regs;
regs.h.ah=0;
regs.h.al=mode;
int86(0x10,&regs,&regs);
}
//---------------------------------------------------------------------------
// PutPixel - Coloca um ponto na tela
void PutPixel(int x,int y,int color)
{
char far *Address=(char far*)0xa0000000L;

Address[y*320+x]=color;
}

// SPRITES/ESTRELAS
//---------------------------------------------------------------------------
struct	StarsStruct
	{
	int x;
	int y;
	int cor;
	};
//---------------------------------------------------------------------------
char *SpriteImage;		// Guarda o sprite
int MaxX=320;			// Maior valor para a coordenada x
int MaxY=400;			// Maior valor para a coordenada y
int NStars=70;			// Numero de estrelas
StarsStruct *rstars;		// Estrelas (coordenas x,y)
//---------------------------------------------------------------------------
// PutFWing_Spr  - desenha o sprite na posicao (x,y)
void PutFWing_Spr(int x,int y)
{
int xf,yf,count;

// Desenha o sprite. Note que cor 255 e' a transparente!
count=0;
for(yf=y;yf<y+20;yf++)
	for(xf=x;xf<x+14;xf++,count++)
		if(SpriteImage[count]!=255)
			PutPixel(xf,yf,SpriteImage[count]);
}
//---------------------------------------------------------------------------
// EraseFWing_Spr - Desenha um retangulo na posicao (x,y), na tentativa
//  de apagar o desenho anterior
void EraseFWing_Spr(int x,int y)
{
int xf,yf;

for(yf=y;yf<y+20;yf++)
	for(xf=x;xf<x+14;xf++)
		PutPixel(xf,yf,0);
}
//---------------------------------------------------------------------------
// InitStars - Inicializa as posicoes iniciais das estrelas
void InitStars(void)
{
int count;

for(count=0;count<NStars;count++)
	{
	rstars[count].x=random(MaxX);
	rstars[count].y=random(MaxY);
	rstars[count].cor=31-random(7);
	}
}
//---------------------------------------------------------------------------
// DrawStars - Desenha as estrelas
void DrawStars(void)
{
int count;

for(count=0;count<NStars;count++)
	PutPixel(rstars[count].x, rstars[count].y, rstars[count].cor);
}
//---------------------------------------------------------------------------
// EraseStars - Apaga as estrelas
void EraseStars(void)
{
int count;

for(count=0;count<NStars;count++)
	PutPixel(rstars[count].x, rstars[count].y, 0);
}
//---------------------------------------------------------------------------
// LoopStars - "Scroll": realiza uma translacao das estrelas na tela
void LoopStars(int pixels)
{
int count;

for(count=0;count<NStars;count++)
	{
	rstars[count].y+=pixels;
	while(rstars[count].y<0) rstars[count].y+=MaxY;
	while(rstars[count].y>=MaxY) rstars[count].y-=MaxY;
	}
}

// TRATAMENTO DE ARQUIVO
//---------------------------------------------------------------------------
// LoadImage - Carrega imagem PCX 14x20 com 256 cores
void LoadImage(char *image)
{
FILE *file;
int count;
int c2,buff,buff2;		// buff - variavel temporaria

// Abre o arquivo de imagem
file=fopen("F-WING.PCX","rb");
if(file==NULL) Erro("Nao foi possivel abrir o arquivo F-WING.PCX\n");

// Posiciona o ponteiro e comeca a leitura
fseek(file,128,SEEK_SET);

// Arquivo pcx esta compactado
for(count=0;count<14*20;)
	{
	buff=fgetc(file);
	if(buff<192)	image[count++]=buff;
		else	{
			buff2=fgetc(file);
			for(c2=0;c2<buff-192;c2++)
				image[count++]=buff2;
			}
	}

// Fecha o arquivo
fclose(file);
}

//---------------------------------------------------------------------------
// Rotinas ISR
void interrupt (far *OldIsr9)(...);
void interrupt (far *OldIsr1C)(...);
void interrupt far KeyControl(...);
void interrupt far Timer(...);
void LoopGame(void);
//---------------------------------------------------------------------------
// ISR - ISR do teclado para controlar as teclas. Note que o Ctrl-Alt-Del
//   deixa de funcionar no Dos e nao e' possivel dar reset. Temos o controle
//   total! Grande parte da rotina foi feita em Assembly.
char Key[5];	// Informacao se a tecla esta pressionada no exato momento
unsigned int Tecla;

void interrupt KeyControl(...)
{
__emit__(0xfb);		// 	sti                     //
__emit__(0xe4,0x60);	//	in	al,60h		//
Tecla=_AL;		//	mov	tecla,al	//
__emit__(0xe4,0x61);	//	in	al,61h		//
__emit__(0x0c,0x82);	//	or	al,82h		//
__emit__(0xe6,0x61);	//	out	61h,al		//
__emit__(0x24,0x7f);	//	and	al,7fh		//
__emit__(0xe6,0x61);	//	out	61h,al		//
__emit__(0xb0,0x20);	//	mov	al,20h		//
__emit__(0xe6,0x20);	//	out	20h,al		//

switch(Tecla)	{
	case	1:	Key[4]=1;	break;	// Esc foi apertada  //
	case	72:	Key[0]=1;	break;	// Up apertada       //
	case	80:	Key[1]=1;	break;	// Down apertada     //
	case	75:	Key[2]=1;	break;	// Left apertada     //
	case	77:	Key[3]=1;	break;	// Right apertada    //

	case	200:	Key[0]=0;	break;	// Up desapertada    //
	case	208:	Key[1]=0;	break;	// Down desapertada  //
	case	203:	Key[2]=0;	break;	// Left desapertada  //
	case	205:	Key[3]=0;	break;	// Right desapertada //
	}
}
//---------------------------------------------------------------------------
// ISR - ISR do temporizador: controla o tempo de operacao. Caso nao houvesse
//   essa rotina, o programa teria funcionamentos diferentes em um 286, 386,
//   486 e um Pentium. Esse ISR compensa as velocidades e permite que o demo
//   se comporte uniformemente para qualquer familia 8086 (exceto nos mais
//   lentos... ;-)
char ResetControls=0;	// Sinalizador de tarefas  1=preparado, 0=aguarde
int XMoved,YMoved;	// Valor dos deslocamentos
char KeyBuf[4];		// Informacao se uma tecla foi pressionada durante
			//                  determinado intervalo de tempo

int const Speed=1;	// Velocidade da nave espacial

void interrupt Timer(...)
{
static times=4;

if(KeyBuf[0])	YMoved=-Speed;
if(KeyBuf[1])	YMoved= Speed;
if(KeyBuf[2])	XMoved=-Speed;
if(KeyBuf[3])	XMoved= Speed;

ResetControls=1;
if(times==0)	{times=5;}
times--;
}
//---------------------------------------------------------------------------
// Responsavel pelo loop principal do demo
void LoopGame(void)
{
int x=160,y=100;	// Posicao da nave espacial
int posic=0,vel=5;	// posic, vel = utilizados para criar um movimento
			//                  mais suaves das estrelas.

DrawStars();		//
PutFWing_Spr(x,y);	// Desenha a tela inicial (estrela e nave)

while(Key[4]!=1)	// Enquanto nao for pressionado Esc...
	{
	if(ResetControls==1) // Preparado?
		{
		// Reseta as teclas
		KeyBuf[0]=KeyBuf[1]=KeyBuf[2]=KeyBuf[3]=0;
		ResetControls=0;

		// Apaga a nave e as estrelas
		EraseFWing_Spr(x,y);
		EraseStars();

		x+=XMoved;	y+=YMoved;	// Move a nave
		XMoved=0;	YMoved=0;

		// Evita que a nave saia fora das coordenadas permitidas
		if(x<0)		x=0;
		if(x>320-14)	x=320-14;

		if(y<0)		y=0;
		if(y>200-20)	y=200-20;

		// Move as estrelas
		LoopStars(posic/vel);
		posic++;
		if(posic>vel) posic=0;

		// Desenha as estrelas e a nave nas posicoes atuais
		DrawStars();
		PutFWing_Spr(x,y);
		}

	// Atualiza resultados
	KeyBuf[0]|=Key[0];
	KeyBuf[1]|=Key[1];
	KeyBuf[2]|=Key[2];
	KeyBuf[3]|=Key[3];
	}
}

////////////////////////////////////////////////////////////////////////////
// main()
void main(void)
{
// Aloca memoria para o programa
SpriteImage=(char*)malloc(14*20);
rstars=(StarsStruct*)malloc(sizeof(StarsStruct)*NStars);

// Caso nao haja memoria suficiente, avisa o usuario.
if(rstars==NULL || SpriteImage==NULL)
	Erro("Falta de memoria\n");

// Carrega uma imagem pcx tamanho 14x20 na memoria
LoadImage(SpriteImage);

// Determina a posicao e a cor das estrelas.
InitStars();
// Modo 0x13 (320x200 256 cores)
SetMode(19);

// Instala ISR na memoria para monitorar o teclado e o temporizador
OldIsr9=getvect(9);
setvect(9,KeyControl);
OldIsr1C=getvect(0x1c);	setvect(0x1c,Timer);
outportb(0x43,0x3c); outportb(0x40,0); outportb(0x40,30);

// Loop principal do demo
LoopGame();

// Desinstala ISR
disable();
setvect(9,OldIsr9);
setvect(0x1c,OldIsr1C);
outportb(0x43,0x3c); outportb(0x40,255); outportb(0x40,255);
enable();

// Volta ao modo texto
SetMode(3);

// Algum texto informativo
printf("F-Wing v0.02 - Ago/98 - Fsc\n");
printf("E-mail: fcatae@hotmail.com\n");
}
